/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package com.cosmodas.FacadeCosmos;

import com.cosmodas.EntCosmos.Abonos;

import java.text.DateFormat;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.List;
import javax.ejb.Stateless;
import javax.persistence.EntityManager;
import javax.persistence.PersistenceContext;
import javax.persistence.Query;

/**
 * @author obper
 */
@Stateless
public class AbonosFacade extends AbstractFacade<Abonos> implements AbonosFacadeLocal {

    @PersistenceContext(unitName = "wcosmodasPersistent")
    private EntityManager em;

    @Override
    protected EntityManager getEntityManager() {
        return em;
    }

    public AbonosFacade() {
        super(Abonos.class);
    }

    @Override
    public String abono_codigo_siguiente(String abono_tipo, String sucursal_ingreso) {
        DateFormat dateFormat = new SimpleDateFormat("yyyy/MM/dd HH:mm:ss");
        Date date = new Date();

        Query consulta = em.createNamedQuery("Abonos.findByAbonoCodSiguiente");
        consulta.setParameter("abonoTipo", abono_tipo);
        consulta.setParameter("sucursalCodigo", sucursal_ingreso);
        consulta.setParameter("fechaAbono", date);

        try {
            return (String) consulta.getSingleResult();
        } catch (Exception e) {
            return null;
        }
    }

    @Override
    public String reciboSiguiente(String abonoTipo, String sucursalCodigo, Date fecha) {
        //DateFormat dateFormat = new SimpleDateFormat("yyyy/MM/dd HH:mm:ss");
        //Date date = new Date();

        Query consulta = em.createNamedQuery("Abonos.findByAbonoCodSiguienteSerieSalas");
        consulta.setParameter("abonoTipo", abonoTipo);
        consulta.setParameter("sucursalCodigo", sucursalCodigo);
        // consulta.setParameter("abonoFecha", fecha);

        try {
            return (String) consulta.getSingleResult();
        } catch (Exception e) {
            return null;
        }
    }

    @Override
    public String ObtenerProximoRecibo(String documentoCodigo) {
        StringBuilder sql = new StringBuilder("SELECT proximo_recibo(?)");
        Query q = em.createNativeQuery(sql.toString());
        q.setParameter(1, documentoCodigo);
        List<String> result = q.getResultList();

        String rs = result.get(0);
        return rs;
    }

}
